#pragma once

#include "OpenGLTrackView.h"

class CLightSetting
{
public:
	bool	m_bLightEnabled;
	GLfloat	m_f4LightPosition[4];
	GLfloat	m_f4LightAmbient[4];
	GLfloat	m_f4LightDiffuse[4];
	GLfloat	m_f4LightSpecular[4];
	GLfloat	m_f3LightSpotDirection[3];
	GLfloat	m_fLightSpotExponent;	// l̋e͈[0, 128]
	GLfloat	m_fLightSpotCutoff;	// l̋e͈[0, 90] or 180
	GLfloat	m_fLightConstantAttenuation;
	GLfloat	m_fLightLinearAttenuation;
	GLfloat	m_fLightQuadraticAttenuation;

public:
	CLightSetting() :
		m_bLightEnabled( 0 ),
		m_fLightSpotExponent( 0 ),	// l̋e͈[0, 128]
		m_fLightSpotCutoff( 180.0f ),	// l̋e͈[0, 90] or 180
		m_fLightConstantAttenuation( 1.0f ),
		m_fLightLinearAttenuation( 0 ),
		m_fLightQuadraticAttenuation( 0 )
	{
		m_f4LightPosition[0] = 0.0f;
		m_f4LightPosition[1] = 0.0f;
		m_f4LightPosition[2] = 1.0f;
		m_f4LightPosition[3] = 0.0f;
		m_f4LightAmbient[0] = 0.0f;
		m_f4LightAmbient[1] = 0.0f;
		m_f4LightAmbient[2] = 0.0f;
		m_f4LightAmbient[3] = 1.0f;
		m_f4LightDiffuse[0] = 0.0f;
		m_f4LightDiffuse[1] = 0.0f;
		m_f4LightDiffuse[2] = 0.0f;
		m_f4LightDiffuse[3] = 1.0f;
		m_f4LightSpecular[0] = 0.0f;
		m_f4LightSpecular[1] = 0.0f;
		m_f4LightSpecular[2] = 0.0f;
		m_f4LightSpecular[3] = 1.0f;
		m_f3LightSpotDirection[0] = 0.0f;
		m_f3LightSpotDirection[1] = 0.0f;
		m_f3LightSpotDirection[2] = -1.0f;
	}
};

// COpenGLLightView r[

class COpenGLLightView : public COpenGLTrackView
{
	// oϐ
private:
	CLightSetting	m_aLightSetting[4];

	// o֐
private:
	bool	SetupLight();
	bool	SetupModelViewMatrix();

	DECLARE_DYNCREATE(COpenGLLightView)

protected:
	COpenGLLightView();           // IŎgp protected RXgN^[
	virtual ~COpenGLLightView();

public:
//	virtual void OnDraw(CDC* pDC);      // ̃r[`悷邽߂ɃI[o[Ch܂B
#ifdef _DEBUG
	virtual void AssertValid() const;
#ifndef _WIN32_WCE
	virtual void Dump(CDumpContext& dc) const;
#endif
#endif

protected:
	DECLARE_MESSAGE_MAP()
};


